#!/usr/bin/env python3
#
# About program:
# CCheck - Checksum checker
# Program for for checking and generate checksums
__version__ = '1.4'
__author__ = 'Karpukhin Pavel <---my@mail.com--->'
__license__ = 'Public Domain'
#__url__ = 'https://---.com'
#


# Import needed modules
import hashlib
import time
import os
from os import system
from os import name
#####


#### Path complete block, works only linux ####
if name != 'nt':
    TmpSyst = 'linux'
    import pathlib
    import readline
    
    # Path Complete body by Peter Mitrano 
    def complete_path(text, state):
        incomplete_path = pathlib.Path(text)
        if incomplete_path.is_dir():
            completions = [p.as_posix() for p in incomplete_path.iterdir()]
        elif incomplete_path.exists():
            completions = [incomplete_path]
        else:
            exists_parts = pathlib.Path('.')
            for part in incomplete_path.parts:
                test_next_part = exists_parts / part
                if test_next_part.exists():
                    exists_parts = test_next_part
                
            completions = []
            for p in exists_parts.iterdir():
                p_str = p.as_posix()
                if p_str.startswith(text):
                    completions.append(p_str)
        return completions[state]
        
    # we want to treat '/' as part of a word, so override the delimiters
    readline.set_completer_delims(' \t\n;')
    readline.parse_and_bind("tab: complete")
    readline.set_completer(complete_path)
    ###############
else:
    TmpSyst = 'windows'
#### Path complete block, end ####


# How many bytes we read by one time
blocksize = 1048576 #now(1M) # 524288(512k) # 262144(256k) #  65536(64k)


# Script colorization (by os.name)
class TxtColors:
    # for Windows
    if name == 'nt':
        ColorEND = ''
        ColorRED = ''
        ColorGREEN = ''
        ColorYELLOW = ''
        ColorBLUEBG = ''
        ColorWHITE = ''
    # for Linux
    else:
        ColorEND = '\33[0m'
        ColorRED = '\33[31m'
        ColorGREEN = '\33[32m'
        ColorYELLOW = '\33[33m'
        ColorBLUEBG = '\33[44m'
        ColorWHITE = '\33[37m'


# Clear screen (by os.name)
def clear():
    # for Windows
    if name == 'nt':
        _ = system('cls')
    # for Linux
    else:
        _ = system('clear')


# Print program name
def program_name():
    print(TxtColors.ColorRED + 'CCheck (Checksum checker)' + TxtColors.ColorEND + '\n')


# Choise you variant for work
def choise_counter():
    chcnt = ''
    while not(chcnt == '1' or chcnt == '2' or chcnt == '3'):
        chcnt = input('Select action:\n ' + TxtColors.ColorYELLOW + '[1]' + TxtColors.ColorEND + ' Calculate hash-summ \n ' + TxtColors.ColorYELLOW + '[2]' + TxtColors.ColorEND + ' Check hash-summ \n ' + TxtColors.ColorYELLOW + '[3]' + TxtColors.ColorEND + ' Close program \n')

    if chcnt == '1':
        return('1')
    elif chcnt == '2':
        return('2')
    else:
        clear()
        exit()


# Choise you variant for hash count
def choise_algoritm():
    chalg = ''
    while not(chalg == '1' or chalg == '2' or chalg == '3' or chalg == '4' or chalg == '5' or chalg == '6' or chalg == '7' or chalg == '8' or chalg == '9' or chalg == '10' or chalg == '11' or chalg == '12' or chalg == '13' or chalg == '14'):
        chalg = input('Which algorithm to use?\n ' + TxtColors.ColorYELLOW + '[1]' + TxtColors.ColorEND + '  SHA-1     | ' + TxtColors.ColorYELLOW + '[2]' + TxtColors.ColorEND + '  SHA-224    | ' + TxtColors.ColorYELLOW + '[3]' + TxtColors.ColorEND + '  SHA-256   | ' + TxtColors.ColorYELLOW + '[4]' + TxtColors.ColorEND + '  SHA-384  | ' + TxtColors.ColorYELLOW + '[5]' + TxtColors.ColorEND + '  SHA-512 |\n ' + TxtColors.ColorYELLOW + '[6]' + TxtColors.ColorEND + '  SHA3-224  | ' + TxtColors.ColorYELLOW + '[7]' + TxtColors.ColorEND + '  SHA3-256   | ' + TxtColors.ColorYELLOW + '[8]' + TxtColors.ColorEND + '  SHA3-384  | ' + TxtColors.ColorYELLOW + '[9]' + TxtColors.ColorEND + '  SHA3-512 |\n ' + TxtColors.ColorYELLOW + '[10]' + TxtColors.ColorEND + ' SHAKE-128 | ' + TxtColors.ColorYELLOW + '[11]' + TxtColors.ColorEND + ' SHAKE-256  | ' + TxtColors.ColorYELLOW + '[12]' + TxtColors.ColorEND + ' BLAKE2b   | ' + TxtColors.ColorYELLOW + '[13]' + TxtColors.ColorEND + ' BLAKE2s  | ' + TxtColors.ColorYELLOW + '[14]' + TxtColors.ColorEND + ' MD-5    |\n')
    
    if chalg == '1':
        return('sha1')
    elif chalg == '2':
        return('sha224')
    elif chalg == '3':
        return('sha256')
    elif chalg == '4':
        return('sha384')
    elif chalg == '5':
        return('sha512')
    elif chalg == '6':
        return('sha3224')
    elif chalg == '7':
        return('sha3256')
    elif chalg == '8':
        return('sha3384')
    elif chalg == '9':
        return('sha3512')
    elif chalg == '10':
        return('shake128')
    elif chalg == '11':
        return('shake256')
    elif chalg == '12':
        return('blake2b')
    elif chalg == '13':
        return('blake2s')
    elif chalg == '14':
        return('md5')
    else:
        return('md5')


# Return to program
def replay():
    return input('Do you want to repeat the calculations? [Yes | No]: \n').lower().startswith('y')


# File name for count checksum
def my_filename():
    fn = ' '
    while (fn == ' '):
        fn = input('Enter the file name: ')
        if len(fn) > 255:
            print(TxtColors.ColorRED + '\nFile path error.\n...' + TxtColors.ColorEND)
            exit()
        #intab = '#@$'
        #outtab = #'#"#"#"#'
        deltab = '"'
        fn_prn = fn.translate(fn.maketrans('', '', deltab))
        
    return (fn_prn)


# File name for check checksum
def checking_hash():
    ch_h = ' '
    while (ch_h == ' '):
        ch_h = input('Enter the source hash: ')
        if len(ch_h) > 2048:
            print(TxtColors.ColorRED + '\nUnfortunately I do not support hashes of this length...\nPerhaps you should look for another program :(' + TxtColors.ColorEND)
            exit()
        
    return (ch_h)


# Print iterations progress
def printProgressBar (iteration, total, prefix = '', suffix = '', decimals = 1, length = 100, fill = '█'):
    """
    Call in a loop to create terminal progress bar
    @params:
        iteration   - Required  : current iteration (Int)
        total       - Required  : total iterations (Int)
        prefix      - Optional  : prefix string (Str)
        suffix      - Optional  : suffix string (Str)
        decimals    - Optional  : positive number of decimals in percent complete (Int)
        length      - Optional  : character length of bar (Int)
        fill        - Optional  : bar fill character (Str)
    """
    percent = ("{0:." + str(decimals) + "f}").format(100 * (iteration / float(total)))
    filledLength = int(length * iteration // total)
    bar = fill * filledLength + '-' * (length - filledLength)
    print('\r%s [ %s ] %s%% %s' % (prefix, bar, percent, suffix), end = '\r')
    # Print New Line on Complete
    if iteration == total: 
        print()


while True:
    clear()
    program_name()
    game_on = True
    
    while game_on:
        if choise_counter() == '1':
            clear()
            program_name()
            print('Calculating the hash sum for a given file \n')
            print('==========Setting parameters for calculation:==========\n')
            
            filename = my_filename()
            ch_algoritm = choise_algoritm()
            statinfo = os.stat(filename)
            fl_sz = round(statinfo.st_size/1024/1024,2)
            lenght_for_shake = statinfo.st_size // 2
            print('\n')
            
            if ch_algoritm == 'sha1':
                hasher = hashlib.sha1()
            elif  ch_algoritm == 'sha224':
                hasher = hashlib.sha224()
            elif  ch_algoritm == 'sha256':
                hasher = hashlib.sha256()
            elif  ch_algoritm == 'sha384':
                hasher = hashlib.sha384()
            elif  ch_algoritm == 'sha512':
                hasher = hashlib.sha512()
            elif  ch_algoritm == 'sha3224':
                hasher = hashlib.sha3_224()
            elif  ch_algoritm == 'sha3256':
                hasher = hashlib.sha3_256()
            elif  ch_algoritm == 'sha3384':
                hasher = hashlib.sha3_384()
            elif  ch_algoritm == 'sha3512':
                hasher = hashlib.sha3_512()
            elif  ch_algoritm == 'shake128':
                hasher = hashlib.shake_128()
            elif  ch_algoritm == 'shake256':
                hasher = hashlib.shake_256()
            elif  ch_algoritm == 'blake2b':
                hasher = hashlib.blake2b()
            elif  ch_algoritm == 'blake2s':
                hasher = hashlib.blake2s()
            else: 
                hasher = hashlib.md5()
            
            start = time.time()
            
            with open(filename,'rb') as f:
                buf = f.read(blocksize)
                
                all_bloks = round(statinfo.st_size / len(buf))
                one_blok = all_bloks / 100
                l = (all_bloks / one_blok) + 1.5
                i = 0
                b = 1.0
                b2 = 1.0
                while len(buf) > 0:
                    hasher.update(buf)
                    buf = f.read(blocksize)
                    i = i + 1
                    if i > b2:
                        b = b + 1.0
                        b2 = b2 + one_blok
                    printProgressBar(b, l, prefix = 'Processed:', suffix = '', length = 50)
                    #print(str(b) + ', ' + str(l))
            
            if ch_algoritm == 'shake128':
                my_hash_result = hasher.hexdigest(128)
            elif ch_algoritm == 'shake256':
                my_hash_result = hasher.hexdigest(256)
            else:
                my_hash_result = hasher.hexdigest()
            
            stop = time.time()
            total_time = stop - start
            result_time = time.strftime("%H:%M:%S", time.gmtime(total_time))
            
            clear()
            program_name()
            print('Calculating the hash sum for a given file \n')
            print('========Current parameters for calculation:========\n')
            
            print('File name  - ' + TxtColors.ColorYELLOW + str(filename) + TxtColors.ColorEND)
            print('File size  - ' + TxtColors.ColorYELLOW  + str(fl_sz) + ' Мб'+ TxtColors.ColorEND)
            print('Algorithm  - ' + TxtColors.ColorYELLOW + str(ch_algoritm) + '\n' + TxtColors.ColorEND)
            
            print('========Calculation results:========\n')
            print('Calculated Hash: ' + TxtColors.ColorGREEN + str(my_hash_result) + TxtColors.ColorEND)
            print('Time spent [hours:minutes:seconds]: ' + TxtColors.ColorYELLOW + str(result_time) + '\n' + TxtColors.ColorEND)
            print('===================================\n')
            game_on = False
            
        else:
            clear()
            program_name()
            print('We check the hash sum of the existing file \n')
            print('==========Setting parameters for calculation:==========\n')
            
            filename = my_filename()
            ch_algoritm = choise_algoritm()
            existing_hash = checking_hash()
            statinfo = os.stat(filename)
            fl_sz = round(statinfo.st_size/1024/1024,2)
            lenght_for_shake = statinfo.st_size // 2
            print('\n')
            
            if ch_algoritm == 'sha1':
                hasher = hashlib.sha1()
            elif  ch_algoritm == 'sha224':
                hasher = hashlib.sha224()
            elif  ch_algoritm == 'sha256':
                hasher = hashlib.sha256()
            elif  ch_algoritm == 'sha384':
                hasher = hashlib.sha384()
            elif  ch_algoritm == 'sha512':
                hasher = hashlib.sha512()
            elif  ch_algoritm == 'sha3224':
                hasher = hashlib.sha3_224()
            elif  ch_algoritm == 'sha3256':
                hasher = hashlib.sha3_256()
            elif  ch_algoritm == 'sha3384':
                hasher = hashlib.sha3_384()
            elif  ch_algoritm == 'sha3512':
                hasher = hashlib.sha3_512()
            elif  ch_algoritm == 'shake128':
                hasher = hashlib.shake_128()
            elif  ch_algoritm == 'shake256':
                hasher = hashlib.shake_256()
            elif  ch_algoritm == 'blake2b':
                hasher = hashlib.blake2b()
            elif  ch_algoritm == 'blake2s':
                hasher = hashlib.blake2s()
            else: 
                hasher = hashlib.md5()
            
            start = time.time()
            
            with open(filename,'rb') as f:
                buf = f.read(blocksize)
                
                all_bloks = round(statinfo.st_size / len(buf))
                one_blok = all_bloks / 100
                l = (all_bloks / one_blok) + 1.5
                i = 0
                b = 1.0
                b2 = 1.0
                while len(buf) > 0:
                    hasher.update(buf)
                    buf = f.read(blocksize)
                    i = i + 1
                    if i > b2:
                        b = b + 1.0
                        b2 = b2 + one_blok
                    printProgressBar(b, l, prefix = 'Processed:', suffix = '', length = 50)
            
            if ch_algoritm == 'shake128':
                my_hash_result = hasher.hexdigest(128)
            elif ch_algoritm == 'shake256':
                my_hash_result = hasher.hexdigest(256)
            else:
                my_hash_result = hasher.hexdigest()
            
            stop = time.time()
            total_time = stop - start
            result_time = time.strftime("%H:%M:%S", time.gmtime(total_time))
            
            clear()
            program_name()
            print('We check the hash sum of the existing file \n')
            print('========Current parameters for calculation:========\n')
            
            print('File name  - ' + TxtColors.ColorYELLOW + str(filename) + TxtColors.ColorEND)
            print('File size  - ' + TxtColors.ColorYELLOW + str(fl_sz) + ' Мб'+ TxtColors.ColorEND)
            print('Algorithm  - ' + TxtColors.ColorYELLOW + str(ch_algoritm) + '\n' + TxtColors.ColorEND)
            
            print('========Calculation results:========\n')
            print('Checked Hash    - ' + TxtColors.ColorWHITE + str(existing_hash).lower() + TxtColors.ColorEND)
            print('Calculated Hash - ' + TxtColors.ColorWHITE + str(my_hash_result).lower() + TxtColors.ColorEND)
            print('Time spent [hours:minutes:seconds]: ' + TxtColors.ColorYELLOW + str(result_time) + TxtColors.ColorEND)
            
            if existing_hash.lower() == my_hash_result.lower():
                print(TxtColors.ColorGREEN + 'Verification was successful.\n' + TxtColors.ColorEND)
            else:
                print(TxtColors.ColorRED + 'Verification failed.\n' + TxtColors.ColorEND)
            
            print('===================================\n')
            game_on = False

    if not replay():
        print('\nBye...\nGood Luck...\n')
        break
